package jp.ac.tuis.sample.sort;

import java.util.Arrays;

/**
 * <p>
 * ̃NXdouble^̔z\[gĕԂ{@link Sorter}C^[tFCX̃XPgłB</p>
 * <p>
 * ̎ł{@link AbstractedSorter#sort(double[])}\bḧ͎QƓnł͂ȂSȃRs[({@link AbstractedSorter#array})𐶐\[gs܂B
 * {@link AbstractedSorter}̎ł
 * {@link AbstractedSorter#array}\[gבւvOɂ
 * {@link AbstractedSorter#sort()}\bhI[o[Ch܂B</p>
 *
 * @author T.Yamaguchi
 */
public abstract class AbstractedSorter implements Sorter, Runnable {

    /**
     * {@link Sorter#sort(double[])}ɂĎ󂯎zRs[ĕێ܂B
     */
    private double[] array;
    /**
     * }`XbhɂsɎs̊mFׂɗp܂B
     */
    private boolean isRunning;
    /**
     * \[gς݂ł邩mFׂɗp܂B
     */
    private boolean isSorted;

    /**
     * yHz
     */
    public AbstractedSorter() {
        isRunning = false;
        isSorted = false;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void run() {
        sort();
    }

    /**
     * {@link Sorter#sort(double[])}̎łB̎ł͈󂯎z{@link AbstractedSorter#array}ɃRs[
     * {@link AbstractedSorter#sort()}\bhɂ\[g܂B
     * {@link AbstractedSorter}pĎꍇsort\bhI[o[ChĂB
     */
    @Override
    public final double[] sort(double[] src) {
        array = Arrays.copyOf(src, src.length);
        isRunning = true;
        isSorted = false;
        sort();
        isRunning = false;
        isSorted = true;
        return array;
    }

    /**
     * {@link AbstractedSorter#array}\[g邱Ƃ
     * {@link AbstractedSorter}ł͎Iȃ\[g̃\bhŋLq܂B
     * {@link AbstractedSorter#array}ւ̃ANZXvf̔rAz̓ւA͂ꂼ̃ANZbT[𗘗pĂB
     *
     * @see AbstractedSorter#get(int) 
     * @see AbstractedSorter#set(int, double) 
     * @see AbstractedSorter#getArray() 
     * @see AbstractedSorter#setArray(double[]) 
     * @see AbstractedSorter#compare(int, int) 
     * @see AbstractedSorter#swap(int, int) 
     */
    protected abstract void sort();

    /**
     * yHz
     */
    protected final double get(int index) {
        return array[index];
    }

    /**
     * yHz
     */
    protected final void set(int index, double value) {
        array[index] = value;
    }

    /**
     * yHz
     */
    protected final double[] getArray() {
        return array;
    }

    /**
     * yHz
     */
    protected final void setArray(double[] array) {
        this.array = array;
    }

    /**
     * yHz
     */
    public boolean isRunning() {
        return isRunning;
    }

    /**
     * yHz
     */
    public boolean isSorted() {
        return isSorted;
    }

    /**
     * yHz
     */
    protected final int size() {
        return array.length;
    }

    /**
     * yHz
     */
    protected final double compare(int i, int j) {
        return array[i] - array[j];
    }

    /**
     * yHz
     */
    protected final void swap(int i, int j) {
        double temp = array[i];
        array[i] = array[j];
        array[j] = temp;
    }
}
