/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jp.ac.tuis.sample.sort;

import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * {@link AbstractedSorter}̕񏈗ɂ}[W\[g̎łB
 * RXgN^thread_depthɂw肵2̗ݏɃXbh𕪊s܂B
 * {@link MergeSortEx}ɂ肻ꂼ\[g}[W\[g̃ASYɂ蕹܂B
 * @author T.Yamaguchi
 */
public class ParallelSort extends AbstractedSorter {

    int thread_depth;
    int thread_number;

    public ParallelSort(int thread_depth) {
        this.thread_depth = thread_depth;
        thread_number = (int) Math.pow(2, thread_depth);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void sort() {
        double[] arrays = getArray();
        double size = (double)arrays.length / thread_number;
        AbstractedSorter[] sorters = new AbstractedSorter[thread_number];
        Thread[] threads = new Thread[thread_number];
        for (int i = 0; i < thread_number; i++) {
            sorters[i] = new MergeSortEx();
//            sorters[i] = new JDKDefaultSort();
            int from = (int)(i * size);
            int to = (int)((i + 1) * size);
            if (to > arrays.length) {
                to = arrays.length;
            }
            sorters[i].setArray(Arrays.copyOfRange(arrays, from, to));
            threads[i] = new Thread(sorters[i]);
            threads[i].start();
        }
        for (Thread thread : threads) {
            try {
                thread.join();
            } catch (InterruptedException ex) {
                Logger.getLogger(ParallelSort.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        double[][] r = new double[thread_number][];
        for (int i = 0; i < r.length; i++) {
            r[i] = sorters[i].getArray();
        }
        for (int d = thread_depth; d > 0; d--) {
            double[][] n = new double[(int) Math.pow(2, d - 1)][];
            Merger[] merger = new Merger[n.length];
            for (int i = 0; i < n.length; i++) {
                merger[i] = new Merger(r[i * 2], r[i * 2 + 1]);
                merger[i].start();
            }
            for (int i = 0; i < n.length; i++) {
                try {
                    merger[i].join();
                } catch (InterruptedException ex) {
                    Logger.getLogger(ParallelSort.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            for (int i = 0; i < n.length; i++) {
                n[i] = merger[i].get();
            }
            r = n;
        }
        setArray(r[0]);
    }

    protected double[] merge(double[] a, double[] b) {
        double[] r = new double[a.length + b.length];
        int i = 0;
        int j = 0;
        for (int c = 0; c < r.length; c++) {
            if (j >= b.length || (i < a.length && a[i] < b[j])) {
                r[c] = a[i];
                i++;
            } else {
                r[c] = b[j];
                j++;
            }
        }
        return r;
    }
}
