package jp.ac.tuis.sample.test;

import java.util.LinkedList;
import java.util.List;
import jp.ac.tuis.sample.sort.BubbleSort;
import jp.ac.tuis.sample.sort.JDKDefaultSort;
import jp.ac.tuis.sample.sort.MergeSort;
import jp.ac.tuis.sample.sort.MergeSortEx;
import jp.ac.tuis.sample.sort.ParallelSort;
import jp.ac.tuis.sample.sort.QuickSort;
import jp.ac.tuis.sample.sort.Sorter;

/**
 * ̃\[gASY̔rs܂B
 * {@link SortEvaluator#add(jp.ac.tuis.sample.sort.Sorter)}ɂ{@link Sorter}̃CX^Xo^A
 * {@link SortEvaluator#evaluation() }sĂB
 *
 * @author T.Yamaguchi
 */
public class SortEvaluator {

    List<Sorter> sorters;
    int array_size;
    int test_number;

    /**
     * z̒Ǝ񐔂w肵܂B
     *
     * @param array_size z̒
     * @param test_number 
     */
    public SortEvaluator(int array_size, int test_number) {
        this.array_size = array_size;
        this.test_number = test_number;
        sorters = new LinkedList<Sorter>();
    }

    /**
     * o^\[gASYꗗ܂B
     */
    public void clear() {
        sorters.clear();
    }

    /**
     * \[gASYo^܂B
     *
     * @param sorter {@link Sorter}̃CX^Xw肵܂B
     */
    public void add(Sorter sorter) {
        sorters.add(sorter);
    }

    /**
     * \[gASY̔rs܂B z񐔂傫ꍇsɎԂ邱Ƃ܂B
     */
    public void evaluation() {
        Problem problem = new RandomArrayProblem(array_size, test_number);
        problem.init();
        problem.print();
        for (Sorter sorter : sorters) {
            TestSet testset = new TestSet(sorter, problem);
            testset.test();
            testset.printResult();
        }

    }

    /**
     * \[gASY̔rsTvłB
     * @param args R}hCp[^
     */
    public static void main(String[] args) {
        SortEvaluator tester = new SortEvaluator(1000, 10);
        tester.add(new JDKDefaultSort());
        //tester.add(new BubbleSort()); //r̓RgAEg邱ƁBӎԂ邱ƂI
        tester.add(new QuickSort());
        tester.add(new MergeSortEx());
        tester.add(new MergeSort());
        tester.add(new ParallelSort(1));
        tester.add(new ParallelSort(2));
        tester.add(new ParallelSort(3));
        tester.add(new ParallelSort(4));
        tester.add(new ParallelSort(5));
        tester.add(new ParallelSort(6));
        tester.evaluation();
    }
}
