package jp.ac.tuis.sample.test;

import jp.ac.tuis.sample.sort.Sorter;

/**
 * Ŝ̃f[^ێ܂B
 *
 * @author T.Yamaguchi
 */
class TestSet {

    Sorter sorter;
    Problem problem;
    long min;
    long max;
    double average;
    double variance;
    double accuracy;

    /**
     * {@link Sorter}{@link Problem}̃CX^Xw肵܂B
     *
     * @param sorter {@link Sorter}̃CX^X
     * @param problem {@link Problem}̃CX^X
     */
    public TestSet(Sorter sorter, Problem problem) {
        this.sorter = sorter;
        this.problem = problem;
    }

    /**
     * s܂B
     */
    public void test() {
        long total = 0;
        int correct = 0;
        min = Long.MAX_VALUE;
        max = Long.MIN_VALUE;
        Test[] testset = new Test[problem.getTestNumber()];
        for (int k = 0; k < testset.length; k++) {
            Test test = new Test(sorter, problem.getProblems(k), problem.getResult(k));
            test.test();
            testset[k] = test;
            total += test.getRunTime();
            if (test.isCorrect) {
                correct++;
            }
            if (min > test.getRunTime()) {
                min = test.getRunTime();
            }
            if (max < test.getRunTime()) {
                max = test.getRunTime();
            }
        }
        average = (double) total / problem.getTestNumber();
        variance = 0.0;
        for (Test test : testset) {
            variance += test.getRunTime() - average;
        }
        variance /= problem.getTestNumber();
        variance /= average;
        accuracy = (double) correct / problem.getTestNumber();
    }

    /**
     * ʂo͂܂B
     */
    public void printResult() {
        System.out.print(sorter.getClass().getName());
        System.out.print(" xF");
        System.out.print(accuracy);
        System.out.print(" ŏF");
        System.out.print(min);
        System.out.print(" őF");
        System.out.print(max);
        System.out.print(" ρF");
        System.out.print(average);
        System.out.print(" UF");
        System.out.print(variance);
        System.out.println();
    }
}
